import Linking from "..";
describe("apis/Linking", function() {
  describe("openURL", function() {
    test("calls open with a url and target", function(done) {
      jest.spyOn(window, "open").mockImplementationOnce(function(url, target, opener) {
        expect(url).toBe("http://foo.com/"), expect(target).toBe("target_name"), expect(opener).toBe("noopener"), done();
      }), Linking.openURL("http://foo.com", "target_name");
    }), test("defaults target to _blank if not provided", function(done) {
      jest.spyOn(window, "open").mockImplementationOnce(function(url, target, opener) {
        expect(url).toBe("http://foo.com/"), expect(target).toBe("_blank"), expect(opener).toBe("noopener"), done();
      }), Linking.openURL("http://foo.com");
    }), test("accepts undefined as a target", function(done) {
      jest.spyOn(window, "open").mockImplementationOnce(function(url, target, opener) {
        expect(url).toBe("http://foo.com/"), expect(target).toBe(void 0), expect(opener).toBe("noopener"), done();
      }), Linking.openURL("http://foo.com", void 0);
    });
  });
});
//# sourceMappingURL=index-test.js.map
